#include <stdio.h>
int main()
{
	char *cmd[4] = {"/bin/sh", "-c", "echo \" works; FOO=$FOO\"", NULL};
	char *env[] = {"FOO=BAR", NULL};
	int st;
	/* execl is already tested in system() */


	printf("execv:\n");
	fflush(stdout);
	if (fork() == 0) {
		execv(cmd[0], cmd);
		exit(1);
	}
	wait(&st);

	printf("execve:\n");
	fflush(stdout);
	if (fork() == 0) {
		execve(cmd[0], cmd, env);
		exit(1);
	}
	wait(&st);

	printf("execl:\n");
	fflush(stdout);
	if (fork() == 0) {
		execl(cmd[0], cmd[0], cmd[1], cmd[2], 0);
		exit(1);
	}
	wait(&st);

	printf("execle:\n");
	fflush(stdout);
	if (fork() == 0) {
		execle(cmd[0], cmd[0], cmd[1], cmd[2], 0, env);
		exit(1);
	}

	wait(&st);
}
