#include <stdio.h>
#include <signal.h>

void sigh(int s)
{
	printf("Got signal %d\n", s);
	fflush(stdout);
	exit(0);
}

int main()
{
	if (signal(SIGALRM, sigh) == (void *)-1) {
		printf("signal() failed\n");
		exit(1);
	}
	printf("Generating sigint\n");
	kill(getpid(), SIGALRM);
	printf("sigh returned?!\n");
	return 1;
}

