/* struct used in returning inode-filename combinations */
typedef struct _v7libc_dirent_s {
	ino_t ino;
	char *name;
} _v7libc_dirent_t;

/* start reading directory entries from dirfd fd (return of open() on
   the dir); cookie doesn't need to be initialized */
void _v7libc_dirstart(void **cookie, int fd);

/* stop reading directory entries and free all memory; fd is not closed
   by this call*/
void _v7libc_dirend(void **cookie);

/* return next entry; the function is reentrant among different cookies
   but a single cookie has only a single buffer for the return value.
   The return value shall not be free'd */
_v7libc_dirent_t *_v7libc_dirnext(void *cookie);

